﻿
component extends="coldbox.system.interceptor"
{
	function preProcess(event,interceptData){
		var rc = event.getCollection();
	}
		
	//------------------------------------------------------------------------------------------------
	// Renderer helper injection
	//------------------------------------------------------------------------------------------------
	public void function afterPluginCreation(event,interceptData){
	  var prc = event.getCollection(private=true);
	 
	  // check for renderer
	  if( isInstanceOf(arguments.interceptData.oPlugin,"coldbox.system.plugins.Renderer") ){
	   // decorate it
	   arguments.interceptData.oPlugin.cr = getMyPlugin(plugin="NewRelic");
	   arguments.interceptData.oPlugin.$cbInject = variables.$cbInject;
	   arguments.interceptData.oPlugin.$cbInject();
	  }
	}
	 
	//------------------------------------------------------------------------------------------------
	// private inject
	//------------------------------------------------------------------------------------------------
	function $cbinject(){
	  variables.cr = this.cr;
	}
	
	//------------------------------------------------------------------------------------------------
	//custom beforeHeadEnd
	//------------------------------------------------------------------------------------------------
	public void function custom_beforeHeadEnd(event, interceptData) {
	  var testString = "";
	  	
		  savecontent variable="testString" {
		   writeOutput("<!-- We have been added from an interceptor before the HEAD ends -->");
		  }
		  appendToBuffer( testString );
	}
	
	//------------------------------------------------------------------------------------------------
	//custom beforeBodyEnd
	//------------------------------------------------------------------------------------------------
	public void function custom_beforeBodyEnd(event, interceptData) {
	  var testString = "";
	  
		  savecontent variable="testString" {
		   writeOutput("<!-- We have been added from an interceptor before the BODY ends -->");
		  }
		  appendToBuffer( testString );
	}
		
		
	}	
