﻿<!-----------------------------------------------------------------------------------------
	CREATED BY NOLAN DUBEAU 03/18/2012 10:00:00 AM
	---------------------------------------------------------------------------------------
	DESCRIPTION:
	New Relic Plugin
	---------------------------------------------------------------------------------------
	AUTHOR: 	Nolan Dubeau
				www.nolandubeau.com
				nolandubeau@gmail.com
				Copyright (c) 2010 Nolan Dubeau. All Rights Reserved.
	---------------------------------------------------------------------------------------
	REVISION HISTORY:
	- None
	---------------------------------------------------------------------------------------
	LICSENES
	This software is bound to the Apache License, Version 2.0.
	--------------------------------------------------------------------------------------->

<cfcomponent name="NewRelic" extends="coldbox.system.plugin" output="false" cache="true" hint="New Relic Plugin">
	
	<!------------------------------------------- CONSTRUCTOR ------------------------------------------->	
   
    <cffunction name="init" access="public" returntype="NewRelic" output="false">
		<cfargument name="controller" type="any" required="true">
		<cfscript>
	  		super.Init(arguments.controller);
	  		setpluginName("NewRelic");
	  		setpluginVersion("1.0");
	  		setpluginAuthor("Nolan Dubeau");
	  		setpluginDescription("New Relic Plugin");
	  		
			variables.instance = StructNew();
	
	  		//Return instance
	  		return this;
		</cfscript>
	</cffunction>
	

	<!------------------------------------------- PUBLIC ------------------------------------------->	
	
	<cffunction name="event" output="true" access="public" returntype="any">
		<cfargument name="state" required="true" type="string"/>
		<cfargument name="data" type="struct" default="#structNew()#"/>

		<cfscript>
			//announce interception
			announceInterception(state=arguments.state ,interceptData=arguments.data);
		</cfscript>
	</cffunction>
	
</cfcomponent>